/* $Header:   K:/man/qedit.c_v   1.1   01 Mar 1993 10:57:14   milow  $ */
/*
 *
 *                     Copyright 1991 Premia Corp.
 *                        All rights reserved
 *
 *    This source code is provided to the purchaser of the product
 *    for the purpose of allowing the purchaser to customize and/or
 *    extend the functionality of the product.  The source code   
 *    remains the property of Premia Corp. with all rights reserved.
 *    Any modifications to the source code are considered derivative
 *    works and all rights thereto are reserved to Premia Corp. except
 *    that the purchaser may use the modified product in the same
 *    permitted manner as the unmodified product.  It is expressly
 *    prohibited to distribute in any manner any part of the original
 *    source code, whether in source or object form, without the
 *    express written permission from Premia Corp.
 *
 *    Owner:
 *        Premia Corporation
 *        1075 NW Murray Blvd., Suite 268
 *        Portland OR 97229
 *
 */					

#include <stdlib.h>
#include <ctype.h>
#include <windows.h>
#include "exports.h"
#include "cwstart.h"


LIBMAIN

static HKEYMAP qeKmap = 0;
static qe_block_type = SELECTION_EXCLUSIVE;
									 
void DLL qedit()
{
	 MsgMessage("Loading qedit Keymap...");

	if (!qeKmap || !KmapQIsValidHandle( qeKmap ))
	{

	     SysCaretHeight( -25, CARET_INSERT );
	     SysCaretHeight( -50, CARET_INSERT_VIRTUAL );
	     SysCaretHeight( 100, CARET_OVERTYPE );
	     SysCaretHeight(  50, CARET_OVERTYPE_VIRTUAL );
	     SysCaretWidth( 100 );

		SrchSetFlags( SEARCH_FORWARD|SEARCH_SELECTION );
		SysSetFlags((SysQFlags() & 
			~( SYSFLAG_CMND_LINE_PROMPT)) |
			(SYSFLAG_STATE_ENABLED | SYSFLAG_TRAP_SYS_KEYS |
			SYSFLAG_MOUSE_WIN_CREATE | SYSFLAG_NEW_WIN_FOR_BUF | 
			SYSFLAG_RETAIN_DIR | SYSFLAG_CONFIG_UPDATE | SYSFLAG_IBEAM_CURSOR |
			SYSFLAG_SHOW_RIBBON | SYSFLAG_CLIPBOARD));
		SysSetDefault( DEFAULT_WINDOW_SYSFLAGS,
			SysQDefault(DEFAULT_WINDOW_SYSFLAGS) | WINDOW_VSCROLLBAR );


     qeKmap = KmapCreate("QEdit");
     KmapSetCurrent(qeKmap);

		AssignMouseKeys();
		KmapAssign( "<mouse_left_down>",         
			"MouseLeftDown SELECTION_EXCLUSIVE 0 1" );
		KmapAssign( "<mouse_right_down>",        "MouseRightDown" );
		KmapAssign( "<Ctrl-mouse_right_click>",  "MouseCopyMove 1");
		KmapAssign( "<Ctrl-Shift-mouse_right_click>", "MouseCopyMove 0");

     KmapAssignTypeables();

     KmapAssignRange( KEY_ASCII_CODE, KEY_ASCII_CODE | 255, "BufInsertChar" );

		KmapAssignRange( KEY_CTRL_CODE | KEY_ALT_CODE | 48, 
			KEY_CTRL_CODE | KEY_ALT_CODE | 57, "BufInsertChar" );

	KmapAssign( "<Alt-1>",    "Upper" );
	KmapAssign( "<Alt-2>",    "Lower" );
	KmapAssign( "<Alt-3>",    "ChangeCase" );
	KmapAssign( "<Alt-A>",    "qe_DropAnchor" );
	KmapAssign( "<Alt-B>",    "WrapParagraph" );
	KmapAssign( "<Alt-Backspace>",	      "Undo");
	KmapAssign( "<Alt-C>",    "qe_copy_move 0" );
	KmapAssign( "<Alt-D>",    "BufDelLine" );
	KmapAssign( "<Alt-E>",    "BufEditFile" );
	KmapAssign( "<Alt-F>",    "SearchQuick" );
	KmapAssign( "<Alt-F10>",  "qe_ShowEntryScreen");
	KmapAssign( "<Alt-F1>",   "qe_ToggleBoxType");
	KmapAssign( "<Alt-F2>",   "qe_InsertLine");
	KmapAssign( "<Alt-F3>",   "qe_Match");
	KmapAssign( "<Alt-F5>",   "qe_ScreenLeft");
	KmapAssign( "<Alt-F6>",   "qe_ScreenRight");
	KmapAssign( "<Alt-F7>",   "ChangeCase");
	KmapAssign( "<Alt-F9>",   "qe_Dos");
	KmapAssign( "<Alt-G>",    "BufDelSelection" );
	KmapAssign( "<Alt-H>",    "CWHelp" );
	KmapAssign( "<Alt-I>",    "ToggleTabsOut" );
	KmapAssign( "<Alt-Insert>",          "Redo");
	KmapAssign( "<Alt-J>",    "qe_JoinLine" );
	KmapAssign( "<Alt-K>",    "qe_MarkColumn" );
	KmapAssign( "<Alt-L>",    "qe_MarkLine" );
	KmapAssign( "<Alt-M>",    "qe_copy_move 1" );
	KmapAssign( "<Alt-N>",    "EditNextBuffer" );
	KmapAssign( "<Alt-O>",    "OutputFile" );
	KmapAssign( "<Alt-R>",    "qe_ReadFile" );
	KmapAssign( "<Alt-S>",    "qe_SplitLine" );
	KmapAssign( "<Alt-U>",    "MarkRemoveSel" );
	KmapAssign( "<Alt-V>",    "qe_ToggleTabs" );
	KmapAssign( "<Alt-W>",    "WriteBuffer" );
	KmapAssign( "<Alt-X>",    "SysExit" );
	KmapAssign( "<Alt-Y>",    "qe_GSave" );
	KmapAssign( "<Alt-Z>",    "qe_CopyOverBlock" );
	KmapAssign( "<Backspace>", "BufBackspace");
	KmapAssign( "<Ctrl-A>",       "qe_WordLeft" );
	KmapAssign( "<Ctrl-B><Ctrl-A>", "qe_AppendScrBuff");
	KmapAssign( "<Ctrl-B>a",      "qe_AppendScrBuff");
	KmapAssign( "<Ctrl-B>A",      "qe_AppendScrBuff");
	KmapAssign( "<Ctrl-B>l",          "qe_GetScrBuff");
	KmapAssign( "<Ctrl-B>s",             "qe_StoreScrBuff");
	KmapAssign( "<Ctrl-Backspace>",  "deletePrevWord" );
	KmapAssign( "<Ctrl-C>",        "MovPageDown" );
	KmapAssign( "<Ctrl-D>",         "MovRight" );
	KmapAssign( "<Ctrl-E>",            "MovUp" );
	KmapAssign( "<Ctrl-End>",            "qe_EndScreen" );
	KmapAssign( "<Ctrl-F1>",		  "CWHelp");
	KmapAssign( "<Ctrl-F>",      "qe_WordRight" );
	KmapAssign( "<Ctrl-G>",		  "qe_delete_chars");
	KmapAssign( "<Ctrl-H>",               "BufBackspace");
	KmapAssign( "<Ctrl-Home>",          "qe_BegScreen");
	KmapAssign( "<Ctrl-I>",          "Redo");
	KmapAssign( "<Ctrl-Insert>",	  "BufInsertScrap");
	KmapAssign( "<Ctrl-J>",           "GotoLine");
	KmapAssign( "<Ctrl-K>0",          "qe_drop_bookmark 10" );
	KmapAssign( "<Ctrl-K>1",          "qe_drop_bookmark 1" );
	KmapAssign( "<Ctrl-K>2",          "qe_drop_bookmark 2" );
	KmapAssign( "<Ctrl-K>3",          "qe_drop_bookmark 3" );
	KmapAssign( "<Ctrl-K>4",          "qe_drop_bookmark 4" );
	KmapAssign( "<Ctrl-K>5",          "qe_drop_bookmark 5" );
	KmapAssign( "<Ctrl-K>6",          "qe_drop_bookmark 6" );
	KmapAssign( "<Ctrl-K>7",          "qe_drop_bookmark 7" );
	KmapAssign( "<Ctrl-K>8",          "qe_drop_bookmark 8" );
	KmapAssign( "<Ctrl-K>9",          "qe_drop_bookmark 9" );
	KmapAssign( "<Ctrl-K><Ctrl-B>",	  "qe_MarkBeginBlock");
	KmapAssign( "<Ctrl-K><Ctrl-C>",	  "qe_copy_move 0");
	KmapAssign( "<Ctrl-K><Ctrl-D>",   "qe_Exit");
	KmapAssign( "<Ctrl-K><Ctrl-e>",   "BufEditFile");
	KmapAssign( "<Ctrl-K><Ctrl-f>",   "OutputFile");
	KmapAssign( "<Ctrl-K><Ctrl-H>",	  "qe_hide_block");
	KmapAssign( "<Ctrl-K><Ctrl-K>",	  "qe_MarkEndBlock");
	KmapAssign( "<Ctrl-K><Ctrl-L>",   "qe_FillBlock");
	KmapAssign( "<Ctrl-K><Ctrl-N>",	  "EditNextBuffer");
	KmapAssign( "<Ctrl-K><Ctrl-n>",   "EditNextBuffer");
	KmapAssign( "<Ctrl-K><Ctrl-P>",   "EditPrevBuffer");
	KmapAssign( "<Ctrl-K><Ctrl-Q>",       "qe_PQuit");
	KmapAssign( "<Ctrl-K><Ctrl-R>",   "qe_ReadBlock");
	KmapAssign( "<Ctrl-K><Ctrl-S>",   "WriteBuffer");
	KmapAssign( "<Ctrl-K><Ctrl-T>",   "SelectWord");
	KmapAssign( "<Ctrl-K><Ctrl-V>",	  "qe_copy_move 1");
	KmapAssign( "<Ctrl-K><Ctrl-W>",	  "WriteBuffer");
	KmapAssign( "<Ctrl-K><Ctrl-Y>",	  "BufDelSelection");
	KmapAssign( "<Ctrl-K>b",		  "qe_MarkBlockBegin SELECTION_EXCLUSIVE");
	KmapAssign( "<Ctrl-K>B",		  "qe_MarkBlockBegin SELECTION_EXCLUSIVE");
	KmapAssign( "<Ctrl-K>c",		  "qe_copy_move 0");
	KmapAssign( "<Ctrl-K>C",		  "qe_copy_move 0");
	KmapAssign( "<Ctrl-K>d",          "qe_Exit");
	KmapAssign( "<Ctrl-K>D",          "qe_Exit");
	KmapAssign( "<Ctrl-K>e",          "BufEditFile");
	KmapAssign( "<Ctrl-K>E",          "BufEditFile");
	KmapAssign( "<Ctrl-K>f",          "OutputFile");
	KmapAssign( "<Ctrl-K>F",          "OutputFile");
	KmapAssign( "<Ctrl-K>h",	"qe_hide_block");
	KmapAssign( "<Ctrl-K>H",	"qe_hide_block");
	KmapAssign( "<Ctrl-K>k",		  "qe_MarkBlockEnd");
	KmapAssign( "<Ctrl-K>K",		  "qe_MarkBlockEnd");
	KmapAssign( "<Ctrl-K>l",          "qe_FillBlock");
	KmapAssign( "<Ctrl-K>L",          "qe_FillBlock");
	KmapAssign( "<Ctrl-K>n",		  "EditNextBuffer");
	KmapAssign( "<Ctrl-K>N",		  "EditNextBuffer");
	KmapAssign( "<Ctrl-K>p",		  "EditPrevBuffer");
	KmapAssign( "<Ctrl-K>P",		  "EditPrevBuffer");
	KmapAssign( "<Ctrl-K>q",             "qe_PQuit");
	KmapAssign( "<Ctrl-K>Q",             "qe_PQuit");
	KmapAssign( "<Ctrl-K>r",          "qe_ReadBlock");
	KmapAssign( "<Ctrl-K>R",          "qe_ReadBlock");
	KmapAssign( "<Ctrl-K>s",          "WriteBuffer");
	KmapAssign( "<Ctrl-K>S",          "WriteBuffer");
	KmapAssign( "<Ctrl-K>T",          "SelectWord");
	KmapAssign( "<Ctrl-K>t",          "SelectWord");
	KmapAssign( "<Ctrl-K>v",		  "qe_copy_move 1");
	KmapAssign( "<Ctrl-K>V",		  "qe_copy_move 1");
	KmapAssign( "<Ctrl-K>w",		  "WriteBuffer");
	KmapAssign( "<Ctrl-K>W",		  "WriteBuffer");
	KmapAssign( "<Ctrl-K>Y",		  "BufDelSelection");
	KmapAssign( "<Ctrl-K>y",		  "BufDelSelection");
	KmapAssign( "<Ctrl-L>",		  "srchCommand 0 0x1206");
	KmapAssign( "<Ctrl-left>",       "qe_WordLeft" );
	KmapAssign( "<Ctrl-M>",          "qe_MacroRecord");
	KmapAssign( "<Ctrl-N>",		  "qe_SplitLine");
	KmapAssign( "<Ctrl-O><Ctrl-L>",  "qe_set_lmargin");
	KmapAssign( "<Ctrl-O><Ctrl-N>",    "qe_EditNextWindow");
	KmapAssign( "<Ctrl-O><Ctrl-P>",   "qe_EditPrevWindow");
	KmapAssign( "<Ctrl-O><Ctrl-R>",  "qe_set_rmargin");
	KmapAssign( "<Ctrl-O><Ctrl-T>",     "CenterLine");
	KmapAssign( "<Ctrl-O><Ctrl-W>",		  "qe_toggle_wrap");
	KmapAssign( "<Ctrl-O><Ctrl-Z>",   "ZoomWindow");
	KmapAssign( "<Ctrl-O>L",		  "qe_set_lmargin");
	KmapAssign( "<Ctrl-O>l",		  "qe_set_lmargin");
	KmapAssign( "<Ctrl-O>n",          "qe_EditNextWindow");
	KmapAssign( "<Ctrl-O>N",          "qe_EditNextWindow");
	KmapAssign( "<Ctrl-O>p",          "qe_EditPrevWindow");
	KmapAssign( "<Ctrl-O>P",          "qe_EditPrevWindow");
	KmapAssign( "<Ctrl-O>R",		  "qe_set_rmargin");
	KmapAssign( "<Ctrl-O>r",		  "qe_set_rmargin");
	KmapAssign( "<Ctrl-O>t",            "CenterLine");
	KmapAssign( "<Ctrl-O>T",            "CenterLine");
	KmapAssign( "<Ctrl-O>W",		  "qe_toggle_wrap");
	KmapAssign( "<Ctrl-O>w",		  "qe_toggle_wrap");
	KmapAssign( "<Ctrl-O>z",          "ZoomWindow");
	KmapAssign( "<Ctrl-O>Z",          "ZoomWindow");
	KmapAssign( "<Ctrl-P>",           "qe_Literal");
	KmapAssign( "<Ctrl-Pagedown>",   "qe_EndFile" );
	KmapAssign( "<Ctrl-Pageup>",     "qe_BegFile" );
	KmapAssign( "<Ctrl-Q>0",          "qe_goto_bookmark 10" );
	KmapAssign( "<Ctrl-Q>1",          "qe_goto_bookmark 1" );
	KmapAssign( "<Ctrl-Q>2",          "qe_goto_bookmark 2" );
	KmapAssign( "<Ctrl-Q>3",          "qe_goto_bookmark 3" );
	KmapAssign( "<Ctrl-Q>4",          "qe_goto_bookmark 4" );
	KmapAssign( "<Ctrl-Q>5",          "qe_goto_bookmark 5" );
	KmapAssign( "<Ctrl-Q>6",          "qe_goto_bookmark 6" );
	KmapAssign( "<Ctrl-Q>7",          "qe_goto_bookmark 7" );
	KmapAssign( "<Ctrl-Q>8",          "qe_goto_bookmark 8" );
	KmapAssign( "<Ctrl-Q>9",          "qe_goto_bookmark 9" );
	KmapAssign( "<Ctrl-Q><Ctrl-A>",	  "srchCommand 0 0x1203");
	KmapAssign( "<Ctrl-Q><Ctrl-C>",   "qe_EndFile" );
	KmapAssign( "<Ctrl-Q><Ctrl-D>",	  "MovEOL" );
	KmapAssign( "<Ctrl-Q><Ctrl-E>",   "qe_BegScreen");
	KmapAssign( "<Ctrl-Q><Ctrl-F>",	  "srchCommand 0 0x1205");
	KmapAssign( "<Ctrl-Q><Ctrl-I>",	  "qe_ToggleIndent");
	KmapAssign( "<Ctrl-Q><Ctrl-R>",   "qe_BegFile" );
	KmapAssign( "<Ctrl-Q><Ctrl-S>",        "MovHome" );
	KmapAssign( "<Ctrl-Q><Ctrl-T>",  "qe_ToggleSmartTabs");
	KmapAssign( "<Ctrl-Q><Ctrl-X>",    "qe_EndScreen");
	KmapAssign( "<Ctrl-Q><Ctrl-Y>",        "BufDelToEOL" );
	KmapAssign( "<Ctrl-Q>a",		  "srchCommand 0 0x1203");
	KmapAssign( "<Ctrl-Q>A",		  "srchCommand 0 0x1203");
	KmapAssign( "<Ctrl-Q>c",   		"qe_EndFile" );
	KmapAssign( "<Ctrl-Q>C",   		"qe_EndFile" );
	KmapAssign( "<Ctrl-Q>d",			  "MovEOL" );
	KmapAssign( "<Ctrl-Q>D",			  "MovEOL" );
	KmapAssign( "<Ctrl-Q>e",         "qe_BegScreen");
	KmapAssign( "<Ctrl-Q>E",         "qe_BegScreen");
	KmapAssign( "<Ctrl-Q>f",		  "srchCommand 0 0x1205");
	KmapAssign( "<Ctrl-Q>F",		  "srchCommand 0 0x1205");
	KmapAssign( "<Ctrl-Q>i",		  "qe_ToggleIndent");
	KmapAssign( "<Ctrl-Q>I",		  "qe_ToggleIndent");
	KmapAssign( "<Ctrl-Q>r",     "qe_BegFile" );
	KmapAssign( "<Ctrl-Q>R",     "qe_BegFile" );
	KmapAssign( "<Ctrl-Q>s",         "MovHome" );
	KmapAssign( "<Ctrl-Q>t",         "qe_ToggleSmartTabs");
	KmapAssign( "<Ctrl-Q>T",         "qe_ToggleSmartTabs");
	KmapAssign( "<Ctrl-Q>x",           "qe_EndScreen");
	KmapAssign( "<Ctrl-Q>X",           "qe_EndScreen");
	KmapAssign( "<Ctrl-Q>y",        "BufDelToEOL" );
	KmapAssign( "<Ctrl-Q>Y",        "BufDelToEOL" );
	KmapAssign( "<Ctrl-R>",          "MovPageUp" );
	KmapAssign( "<Ctrl-right>",      "qe_WordRight" );
	KmapAssign( "<Ctrl-S>",            "MovLeft" );
	KmapAssign( "<Ctrl-Shift-C>",    "BufSetCompact" );
	KmapAssign( "<Ctrl-Shift-H>",    "BufSetHexBinary" );
	KmapAssign( "<Ctrl-Shift-T>",    "BufSetAscii" );
	KmapAssign( "<Ctrl-T>", 		"deleteNextWord" );
	KmapAssign( "<Ctrl-U>",	      "Undo");
	KmapAssign( "<Ctrl-V>",		  "InsertMode");
	KmapAssign( "<Ctrl-W>",       "WinScrollV 1" );
	KmapAssign( "<Ctrl-X>",            "MovDown" );
	KmapAssign( "<Ctrl-Y>",          "BufDelLine 1" );
	KmapAssign( "<Ctrl-Z>",         "WinScrollV -1" );
	KmapAssign( "<Del>",			  "qe_delete_chars");
	KmapAssign( "<down>",            "MovDown" );
	KmapAssign( "<End>",			  "MovEOL" );
	KmapAssign( "<Enter>",           "BufInsertEOL" );
	KmapAssign( "<F1>",              "CWHelp");
	KmapAssign( "<F2>",              "qe_AddLine");
	KmapAssign( "<F3>",              "qe_GPQuit");
	KmapAssign( "<F4>",              "qe_DupLine");
	KmapAssign( "<F5>",              "qe_MakeTopOfScreen");
	KmapAssign( "<F6>",              "qe_DelToEol");
	KmapAssign( "<F7>",              "qe_MarkBlockBegin");
	KmapAssign( "<F8>",              "qe_MarkBlockEnd");
	KmapAssign( "<F9>",              "qe_Shell");
	KmapAssign( "<Home>",            "MovHome" );
	KmapAssign( "<left>",            "MovLeft" );
	KmapAssign( "<Pagedown>",        "MovPageDown" );
	KmapAssign( "<Pageup>",          "MovPageUp" );
	KmapAssign( "<right>",           "MovRight" );
	KmapAssign( "<Shift-Backspace>", "BufBackspace");
	KmapAssign( "<Shift-Del>",		  "BlockCut");
	KmapAssign( "<Shift-F10>",		  "ExecuteMacro");
	KmapAssign( "<Shift-F1>",         "qe_ToggleBoxDraw");
	KmapAssign( "<Shift-F3>",         "qe_Sort");
	KmapAssign( "<Shift-F5>",         "qe_MakeCtrOfScreen");
	KmapAssign( "<Shift-F7>",         "qe_ShiftLeft");
	KmapAssign( "<Shift-F8>",         "qe_ShiftRight");
	KmapAssign( "<Shift-Insert>",	  "Paste");
	KmapAssign( "<Shift-Space>",	  "BufInsertChar 32");
	KmapAssign( "<Space>",            "Space" );
	KmapAssign( "<Tab>",              "Tab" );
	KmapAssign( "<up>",              "MovUp" );
//	KmapAssign( "<Ctrl-B>",	"WrapParagraph" );
//	KmapAssign( "<Ctrl-K>x             File
//	KmapAssign( "<Ctrl-K>z             KillFile
//	KmapAssign( "<Ctrl-O>c             CloseWindow
//	KmapAssign( "<Ctrl-O>g             GrowWindow
//	KmapAssign( "<Ctrl-O>h             HorizontalWindow
//	KmapAssign( "<Ctrl-O>o             OneWindow
//	KmapAssign( "<Ctrl-O>s             ShrinkWindow
//	KmapAssign( "<Ctrl-Q>b             GotoBlockBeg
//	KmapAssign( "<Ctrl-Q>k             GotoBlockEnd
//	KmapAssign( "<Ctrl-Q>l             UndoCursorline
//	KmapAssign( "<Ctrl-Q>p             PrevPosition
//	KmapAssign( "<Ctrl-Q>q             RepeatCmd
//	KmapAssign( "<Ctrl-U               UnKill

	}
	else
	{
		/* The keymap had already been created, just make it current.
		 */
		KmapSetCurrent( qeKmap );
	}

     MsgMessage("QEdit command set in effect.");
}

void DLL qe_GSave()  
{
	if (BufQModified() > 0)
	{
		MsgMessage("Saving file...");
		if (BufWrite() == 0)
			MsgMessage("File saved.");
		else
			MsgMessage("Error writing file.");
	}
}

void DLL qe_WordRight()
{
	NextWord();
}


void DLL qe_WordLeft()	  
{
	PrevWord();
}

void DLL qe_delete_chars() 
{
	if (MarkQSelType() == SELECTION_NONE)
		BufDelChar( 1 );
	else
		BufDelSelection();
}	

void DLL qe_copy_move(int moveIt )
{
	if (MarkQSelType() > 0)
	{
		if (moveIt != 0)
			BufCutToScrap();
		else
			BufCopyToScrap();
		BufInsertScrap();
	}
	else
		MsgWarning("No selection defined.");
}

LPSTR DLL BufferName()
{
     if (BufQOutputName() == NIL)
        return BufQFilename();
     else
         return BufQOutputName();
}

void DLL qe_EndFile()  
{
	MovEOF();
	MovEOL();
}

void DLL qe_BegFile()  
{
	MovTopBuf();
	MovHome();
}
		
void DLL qe_exec_run() 
{
	SysExec(TransformFilename(BufferName(),"%b"),"",0);	 
}

void DLL
qe_drop_bookmark( int num )
{
	int ch;
	if (num == 0)
		num = 10;

	if (MarkQInUse( MARK_GLOBAL | num ))
	{
		ch = MsgConfirm( "Overwrite existing bookmark (Y/N)? ", "yYnN" );

		/* The mark has already been used once, see if the user wishes
		 * to overwrite it.
		 */

		if (ch != 'Y' && ch != 'y')
		{
			MsgMessage( "Command cancelled." );
			return;
		}
	}

	if (MarkCreateGlobal( num ) )
		MsgMessage( "Bookmark dropped." );
}

void DLL qe_goto_bookmark( int num )
{
	MarkGoto(MARK_GLOBAL | num);
}

void DLL qe_toggle_wrap()
{
	if ( WrapEnable(-1) )
	{
		WrapEnable( 0 );
		MsgMessage("Word wrap OFF");
	}
	else
	{
		WrapEnable( 2 );
		MsgMessage("Word wrap ON");
	}
}

void DLL qe_set_rmargin()
{
	LPSTR margin;
	int mVal;

	margin = MsgPromptHistory("RMARGIN","New right margin setting: ","70");
	if (margin)
	{
		mVal = atoi( margin );
		if ( mVal >= 0 )
		{
			WinVisibleMarginColumn( mVal );
			MsgPrintf(0,"Right margin set to %d",mVal);
		}
	}
}

void DLL qe_set_lmargin()
{
	LPSTR margin;
	int mVal;

	margin = MsgPromptHistory("RMARGIN","New left margin setting: ","10");
	if (margin)
	{
		mVal = atoi( margin );
		if ( mVal >= 0 )
		{
			WinLeftMargin( mVal );
			MsgPrintf(0,"Left margin set to %d",mVal);
		}
	}
}

void DLL qe_toggle_block_type()
{
	if (qe_block_type == SELECTION_EXCLUSIVE)
	{
		qe_block_type = SELECTION_COLUMN;
		MsgMessage("Column selection mode ON.");
	}
	else
	{
		qe_block_type = SELECTION_EXCLUSIVE;
		MsgMessage("Column selection mode OFF.");
	}
}


static	Selection last_sel = {0};

void DLL qe_hide_block()
{
	MarkID saved_pos;

	if ( MarkQSelType() )
	{
		if ( MarkQIsSelOpen() )
			MarkEndSel();
		MarkGetSelInfo(&last_sel,!(MarkQSelType() & SELECTION_EXCLUSIVE));
		MarkRemoveAllSel();
		MsgMessage("Block hidden.");
	}
	else
	{
		if (last_sel.selType)
		{
			saved_pos = MarkAllocGlobal();
			BufSetCurrentBuffer(last_sel.hBuffer);
			MovAbs(last_sel.begin.line,	last_sel.begin.column);
			MarkBeginSel(last_sel.selType);
			MovAbs(last_sel.end.line,	last_sel.end.column);
			MarkEndSel();
			MarkGoto(saved_pos);
			MarkFree(saved_pos);
			MsgMessage("Block revealed.");
		}
		else
			MsgWarning("No hidden block defined.");
	}
}

void DLL _init() 
{
	LibExport("qedit");
	LibExport("qe_AddLine");
	LibExport("qe_AppendScrBuff");
	LibExport("qe_BegFile");
	LibExport("qe_BegScreen");
	LibExport("qe_CopyOverBlock" );	
	LibExport("qe_copy_move int");
	LibExport("qe_delete_chars");
	LibExport("qe_DelToEol");
	LibExport("qe_Dos");
	LibExport("qe_DropAnchor" );	
	LibExport("qe_drop_bookmark int");
	LibExport("qe_DupLine");
	LibExport("qe_EditNextWindow");
	LibExport("qe_EditPrevWindow");
	LibExport("qe_EndFile");
	LibExport("qe_EndScreen" );
	LibExport("qe_Exit");
	LibExport("qe_exec_run");
	LibExport("qe_FillBlock");
	LibExport("qe_GetScrBuff");
	LibExport("qe_StoreScrBuff");
	LibExport("qe_goto_bookmark int");
	LibExport("qe_GPQuit");
	LibExport("qe_GSave" );	
	LibExport("qe_hide_block");
	LibExport("qe_InsertLine");
	LibExport("qe_JoinLine" );
	LibExport("qe_Literal");	
	LibExport("qe_MakeCtrOfScreen");
	LibExport("qe_MakeTopOfScreen");
	LibExport("qe_MarkBlockBegin int");
	LibExport("qe_MarkBlockEnd");
	LibExport("qe_MarkColumn" );	
	LibExport("qe_MarkLine" );	
	LibExport("qe_Match");
	LibExport("qe_WordRight");			  
	LibExport("qe_WordLeft");
	LibExport("qe_PQuit");
	LibExport("qe_MacroRecord");
	LibExport("qe_ReadBlock");
	LibExport("qe_ReadFile" );
	LibExport("qe_ScreenLeft");
	LibExport("qe_ScreenRight");
	LibExport("qe_set_lmargin");
	LibExport("qe_set_rmargin");
	LibExport("qe_Shell");
	LibExport("qe_ShiftLeft");
	LibExport("qe_ShiftRight");
	LibExport("qe_ShowEntryScreen");
	LibExport("qe_Sort");
	LibExport("qe_SplitLine" );	
	LibExport("qe_ToggleBoxDraw");
	LibExport("qe_ToggleBoxType");
	LibExport("qe_ToggleIndent");
	LibExport("qe_toggle_block_type");
	LibExport("qe_ToggleSmartTabs");
	LibExport("qe_toggle_wrap");
	LibExport("ChangeCase");
	qedit();
}

void DLL
qe_AddLine()
{
	MarkSavePos();
	MovHome();
	BufInsertEOL();
	MarkRestorePos();
}




void DLL
qe_GPQuit()
{
	BOOL okToExit = TRUE;

	if (BufQModifiedCount(FALSE))
		okToExit = !!LibFunctionExec(
		"DlgBufferSave 0, 'Exit with modified buffers'");
	if (okToExit)
	   SysQuit(0);	
}

void DLL
qe_DupLine()
{
	MarkBeginSel(SELECTION_LINE);
	BufCopyToScrap();
	BufInsertScrap();
}

void DLL
qe_MakeTopOfScreen()
{
	ToTop();
}

void DLL
qe_DelToEol()
{
	BufDelToEOL();
}

void DLL
qe_MarkBlockBegin(int SelType)
{
	int TestType = MarkQSelType();

	if (TestType > 0)
	{
		if (TestType == SelType)
		{
			MarkSet(MarkQSelBeginID(),BufQCurrentLine(),BufQCurrentCol());
		}
		else
			MarkRemoveSel();
	}
	else
		MarkBeginSel(SelType);
}

void DLL
qe_MarkBlockEnd()
{
	if (MarkQSelType() > 0)
	{
		if (MarkQIsSelOpen() == 0)
			MarkResumeSel();
		MarkEndSel();
	}
	else
		MsgWarning("No selection defined.");
}

void DLL
qe_Shell()
{
	ExecCommand("");
}

static BOOL qe_Line_Draw = FALSE;

void DLL
qe_ToggleBoxDraw()
{
	if (qe_Line_Draw)
	{
		KmapAssign( "<down>",            "MovDown" );
		KmapAssign( "<left>",            "MovLeft" );
		KmapAssign( "<right>",           "MovRight" );
		KmapAssign( "<up>",              "MovUp" );
		qe_Line_Draw = FALSE;
	}
	else
	{
		KmapAssign( "<down>",            "LDDown" );
		KmapAssign( "<left>",            "LDLeft" );
		KmapAssign( "<right>",           "LDRight" );
		KmapAssign( "<up>",              "LDUp" );
		qe_Line_Draw = TRUE;
	}
}

void DLL
qe_Sort()
{
	MsgMessage("Unimplemented.");
}

void DLL
qe_MakeCtrOfScreen()
{
	CenterLine();
}

void DLL
qe_ShiftLeft()
{
	MarkSavePos();
	MovHome();
	BufDelChar(1);
	MarkRestorePos();
}

void DLL
qe_ShiftRight()
{
	MarkSavePos();
	MovHome();
	BufInsertChar(32);
	MarkRestorePos();
}

void DLL
qe_ToggleBoxType()
{
	int TBT_response = 0;

	TBT_response = MsgConfirm("style: Single, double Top, douBle side, Double",
		"SsTtBbDd");
	if (TBT_response != 27)
	{
		switch (TBT_response)
		{
		case 's':
		case 'S': LibFunctionExec("SetLineDrawStyle 1 ");
			break;
		case 't':
		case 'T': LibFunctionExec("SetLineDrawStyle 3 ");
			break;
		case 'b':
		case 'B': LibFunctionExec("SetLineDrawStyle 2 ");
			break;
		case 'd':
		case 'D': LibFunctionExec("SetLineDrawStyle 4 ");
			break;
		}
	}
}

void DLL
qe_InsertLine()
{
	MarkSavePos();
	MovEOL();
	BufInsertEOL();
	MarkRestorePos();
}


void DLL
qe_Match()
{
	BraceMatch(TRUE);
}

void DLL
qe_ScreenRight()
{
	if ( WinQLeftColumn() > 1 )
    {
		WinScrollH( 1 );
		MovLeft( 1 );
	}
}

void DLL
qe_ScreenLeft()
{
	if ( WinScrollH( -1 ) )
		MovRight( 1 );
}

void DLL
qe_Dos()
{
	LibFunctionExec("ExecApp ''");
}

void DLL
qe_ShowEntryScreen()
{
	MsgMessage("Unimplemented.");
}

void DLL
qe_BegScreen()
{
	MovTopWin();
	MovHome();
}

void DLL
qe_EndScreen()
{
	MovEndWin();
	MovEOL();
}

BOOL DLL
SelectFilename( void )
{
	WORD ch;

	MarkSavePos();

	/* Locate the first keyword character (non-punctuation).
	 */
	ch = BufReadChar();
	while (!isalnum(ch) && (ch != '_') && (ch != '.'))
	{
		if (!MovPrevChar( 1 ))
			break;
		ch = BufReadChar();
	}

	/* Skip over all the normal characters.
	 */
	do
	{
		ch = BufReadChar();
		if (!isalnum(ch) && ch != '_' && ch != '.')
		{
			MovNextChar( 1 );
			break;
		}
	} while( MovPrevChar( 1 ) );

	MarkBeginSel( SELECTION_EXCLUSIVE );

	/* Locate the last keyword character (non-punctuation).
	 */
	ch = BufReadChar();
	while (isalnum(ch) || (ch == '_') || (ch == '.'))
	{
		if (!MovNextChar( 1 ))
			break;
		ch = BufReadChar();
	}

	MarkEndSel();
	MarkRestorePos();
	return TRUE;
}

			 //foo.pas
void DLL
qe_OpenCursorFile()
{
	LPSTR CFilename;

	SelectFilename();
	CFilename = StrNormalizePath(MarkGetSelStr(NIL, NIL));
	if (CFilename && *CFilename)
		BufEditFile(CFilename);
	else
		MsgWarning("No filename found at cursor.");
}

void DLL
qe_ReadFile(void)
{
	LPSTR fname;

	if (BufQIsReadOnly())
		return;

	fname = MsgPromptHistory( "EDITFILE", "File to read: ", "" );

	if (fname)
	{
		if (*fname)
		{
			MsgMessage( "Reading..." );
			if (BufInsertFile( fname ) )
				MsgWarning( "File not found." );
			else
				MsgMessage( "File read." );
		}
		else
			MsgMessage( "" );
	}
}

void DLL
qe_mark( int mark_type )                         /* Alt-m */
{
	int old_mark_type  = MarkQSelType();

	/* mark_type is one of the following */
	/*   1 = inclusive                   */
	/*   2 = column                      */
	/*   3 = line                        */
	/*   4 = noninclusive                */
	if (mark_type < 0 || mark_type > 4)
		return;

	if (old_mark_type == mark_type)
	{
		/* The current selection type is the same as the new one so remove it */
		MarkRemoveSel();
	}
	else if (old_mark_type)
	{
		/* A selection type overlays an existing selection */
		MarkSavePos();
		MarkSwapSel();
		MarkRemoveSel();
		MarkBeginSel( mark_type );
		MarkRestorePos();
	}
	else
	{
		/* No previous selection, just start a new selection */
		MarkBeginSel( mark_type );
	}
}

void DLL
qe_DropAnchor()
{
	qe_mark(SELECTION_INCLUSIVE);
}


void DLL qe_MarkToggle( SelType )
{
	int curType= MarkQSelType();

	// Does a selection currently exist? 
	if (curType > 0)
	{
		// Is the selection the correct type?
		if (curType == SelType)
		{
			// Then close it.
			qe_MarkBlockEnd();
		}
		else
		{
			// remove it and start over.
			MarkRemoveSel();
			qe_MarkBlockBegin( SelType );
		}
	}
	else
		// if not create one.
		qe_MarkBlockBegin( SelType );
}

void DLL
qe_MarkLine()
{
	qe_MarkToggle(SELECTION_LINE);	
}

void DLL
qe_MarkColumn()
{
	qe_MarkToggle(SELECTION_COLUMN);
}

void DLL
qe_JoinLine()
{
	MarkSavePos();
	MovEOL();
	BufDelChar( 1 );
	MarkRestorePos();
}

void DLL 
qe_SplitLine() 
{
	MarkSavePos();
	BufInsertEOL();
	MarkRestorePos();
}

void DLL
qe_ToggleTabs()
{
	BufToggleSysFlags(BUFFER_USE_TABS);
	if (BufQTabUsage())
		MsgMessage("Tab usage enabled");
	else
		MsgMessage("Space fill enabled");
}

void DLL
qe_CopyOverBlock()
{
	BufDelSelection();
	Paste();
}

void DLL
qe_AppendScrBuff()
{
	if (MarkQSelType())
	{
		BufAppendToScrap();
		MsgMessage("Selection appended to scrap.");
	}
	else
		MsgWarning("No selection defined.");
}

void DLL
qe_GetScrBuff()
{
	MsgMessage("Unimplemented.");
}

void DLL
qe_StoreScrBuff()
{
	MsgMessage("Unimplemented.");
}

void DLL
qe_Literal(void)
{
	int ascii_ch, ch;

	if (BufQIsReadOnly())
		return;

	ch       = KeyGetVKey();
	ascii_ch = KeyToAscii( ch );

	if (ascii_ch )
	{
		BufDelSelection();
		BufInsertChar( ascii_ch );
	}
	else
		KeyUnget( (WORD)ch );
}

void DLL
qe_EditNextWindow()
{
	WinSetCurrentWindow( WinQNext( 0 ) );

	DisplayFileName();
}

void DLL
qe_EditPrevWindow()
{
	WinSetCurrentWindow( WinQPrev( 0 ) );
	DisplayFileName();
}

void DLL
qe_Exit()
{
	int respCh;

	if ( BufQModified() )
	{
		respCh = MsgConfirm("Save changes before closing? (Y/N)","YyNn");
		switch (respCh)
		{
		case 'Y':
		case 'y': WriteBuffer();
			break;
		case 27: return;
		}
	}
	BufDelBuffer(BufQCurrentBuffer());
	if ( !BufQBufferCount( 0 ) )
	   BufEditFile( "" );
}

void DLL
qe_PQuit()
{
	int respCh;

	if ( BufQModified() )
	{
		respCh = MsgConfirm("Lose changes? (Y/N)","YyNn");
		switch (respCh)
		{
		case 'Y':
		case 'y': 
			break;
		default: return;
		}
	}
	BufDelBuffer(BufQCurrentBuffer());
	if ( !BufQBufferCount( 0 ) )
	   BufEditFile( "" );
}

void DLL
qe_FillBlock()
{
	LPSTR FillWith;

	if (MarkQSelType())
	{
		FillWith = MsgPrompt("Fill with: ","","FILLCHAR");
		if (FillWith && *FillWith)
			CharFill(FillWith);
	}
}

void DLL
qe_MacroRecord()
{
	int ch;

	switch ( KeyQRecording() ) 
	{
	case 0:     /* not recording or playing */
		if (KeyQRecordString())
			/* a recorded string exists, query to overwrite */
		{
			ch = MsgConfirm( "Overwrite existing keystroke macro [yn]?",
					"yYnN" );
			if (ch != 'Y' && ch != 'y')
			{
				if (ch == 'N' || ch == 'n')
					MsgMessage("");
				else
					MsgMessage("Command cancelled." );
				break;
			}
		}
		MsgMessage( "Defining keystroke macro." );
		KeyRecord( 1 );
		break;
	case 1:     /* currently recording */
		MsgMessage( "Keystroke macro defined." );
		KeyRecord( 0 );
		break;
	case 2:     /* currently playing */
		break;
	}
}

void DLL
qe_ToggleIndent()
{
	BufToggleSysFlags(BUFFER_AUTO_INDENT);

	if (BufQSysFlags() & BUFFER_AUTO_INDENT)
		MsgMessage("Auto-indent ON");
	else
		MsgMessage("Auto-indent OFF");
}

void DLL
qe_ToggleSmartTabs()
{
	LPSTR ext;
	int   level;
	
	StrSplitpath(BufQFilename(), NIL, NIL, NIL, &ext);
	ExtQIndenting(ext);
	if (level & 1 )
	{
		ExtIndentEnableAssoc(ext,level - 1);
		MsgMessage("Smart indenting toggled off");
	}
	else
	{
		ExtIndentEnableAssoc(ext,level + 1);
		MsgMessage("Smart indenting toggled on");
	}
}

void DLL
qe_ReadBlock()
{
	LPSTR InsertFile = MsgPrompt("File to read: ","", "EDITFILE");

	InsertFile = StrNormalizePath(InsertFile);
	if (InsertFile && *InsertFile)
		if (BufInsertFile(InsertFile))
			MsgWarning("Cannot open read file.");
}

void DLL 
ChangeCase( void )
{
	BOOL noselection = FALSE;

	LibExport( "int _do_changecase LONG" );

	if (MarkQSelType() == SELECTION_NONE)
	{
		MarkBeginSel( SELECTION_LINE );
		noselection = TRUE;
	}

	_do_block( "_do_changecase" );

	if (noselection)
		MarkRemoveSel();
}

int DLL
_do_changecase( LPVOID XFAR *ptr )
{
	LPSTR str;

	if (ptr && *ptr)
	{
		str = *ptr;
		while (*str)
		{
			*str = isupper( (BYTE)*str ) ? tolower( *str ) : toupper( *str );
			str++;
		}
	}
	return 1;
}


